@echo off

echo Creating %1.xsl from %1.html 
if not exist %1.html goto :errorfo

echo Preview the literate result instance for visually accuracy
start %1.html

echo Validate the use of LiterateXSLT vocabulary in the literate result instance
call ..\support\rnc.bat ..\support\Crane-LiterateXSLT.rnc %1.html
if %errorlevel% GTR 0 goto :error

if not exist %2.xml goto :skip-validation

echo Determine the complete XPath expressions in the literate result instance
call ..\support\xslt2.bat %1.html ../support/lit2xpath.xsl %1-lit.xml
if %errorlevel% GTR 0 goto :error

echo Refine the complete XPath expressions from the literate result instance
python ..\support\xpathall.py <%1-lit.xml >%1-xpath.xml

echo Determine the possibly invalid XPath used in the literate result instance
call ..\support\xslt2.bat 2>%1-bad.txt %1-xpath.xml ../support/xml4lit.xsl nul "xmlfile=%2.xml"
echo Report of possibly invalid XPath expressions
type %1-bad.txt

:skip-validation

echo Produce the XSLT stylesheet from the literate result instance
call ..\support\xslt2.bat %1.html ../support/Crane-LiterateXSLT.xsl %1.xsl
if %errorlevel% GTR 0 goto :error

echo Produce a candidate result from the generated stylesheet
call ..\support\xslt2.bat %1.xml %1.xsl %1-result.html
if %errorlevel% GTR 0 goto :error

echo Preview the candidate result
start %1-result.html

goto :done

:errorfo
echo Missing %1.html file

:error
echo  A problem was detected!

:done
rem Done!
