<?xml version="1.0" encoding="iso-8859-1"?>
<?xml-stylesheet type="text/xsl" href="../xslstyle/xslstyle-docbook.xsl"?>
<xst:stylesheet
  xmlns:xst="http://www.w3.org/1999/XSL/Transform"
  xmlns:xsl="dummy"
  xmlns:xs="http://www.CraneSoftwrights.com/ns/xslstyle"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:x="http://www.CraneSoftwrights.com/ns/literate-xslt"
  xmlns:xi="http://www.CraneSoftwrights.com/ns/literate-xslt/internal"
  xmlns:a="http://www.CraneSoftwrights.com/ns/literate-xslt/attribute"
  exclude-result-prefixes="xst x a xs xsd xi"
  version="2.0">

<xs:doc info="$Id: Crane-LiterateXSLT.xsl,v 1.62 2019/04/18 02:36:29 admin Exp $"
        filename="Crane-LiterateXSLT.xsl" vocabulary="DocBook"
        global-ns="x" internal-ns="xi">
  <xs:title>LiterateXSLT&#x2122; - synthesizing XSLT stylesheets</xs:title>
  <para>
    A XSLT stylesheet to create an XSLT from an annotated prototypical
    result instance.
  </para>
  <para>
    This document is the stylesheet documentation for the
    LiterateXSLT&#x2122; environment, not the user documentation.
    See <ulink url="../doc/readme-Crane-LiterateXSLT.html"
    ><literal>readme-Crane-LiterateXSLT.html</literal></ulink> for the user
    documentation.
  </para> 
<programlisting>
Copyright (C) - Crane Softwrights Ltd.
              - http://www.CraneSoftwrights.com/links/res-lxslts.htm

Redistribution and use in source and binary forms, with or without 
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, 
  this list of conditions and the following disclaimer. 
- Redistributions in binary form must reproduce the above copyright notice, 
  this list of conditions and the following disclaimer in the documentation 
  and/or other materials provided with the distribution. 
- The name of the author may not be used to endorse or promote products 
  derived from this software without specific prior written permission. 

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN 
NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Note: for your reference, the above is the "Modified BSD license", this text
      was obtained 2003-07-26 at http://www.xfree86.org/3.3.6/COPYRIGHT2.html#5
</programlisting>
  <para>
    Note this is an XSLT 2.0 adaptation of an XSLT 1.0 original stylesheet
    so may not take advantage of all XSLT 2.0 facilities available.
  </para>
</xs:doc>

<!-- Vocabulary summary:

 Elements:

   x:envelope - envelope a payload of input with some verbatim content
   x:verbatim - verbatim content available to be injected into result
   x:payload - a container of input for use in an envelope
   x:replace - an indication of content that replaces sibling content
   x:branch - create a branch in logic but not in the result tree
   x:global-variable - the declaration of a variable of global scope
   x:local-variable - the declaration of a variable of local scope
   x:message - report information and conditionally terminate

 Attributes (listed in order documented in readme-CraneLiterateXSLT.html):

   x:preserve-space="white-space-separted-list-of-element-patterns"
   x:strip-space="white-space-separted-list-of-element-patterns"
   x:exclude-result-prefixes="white-space-sparated-list-of-prefixes"
   x:xpath-default-namespace="namespace-uri"
   x:indent="yes-or-no-default-no"
   xml:space="default"
   xml:space="preserve"

   x:condition="test-expression"

   x:match="pattern-expression"
   x:mode="mode-name"
   x:priority="numeric-value"

   @a:*="result-stylesheet-XPath-expression-for-named-attr"
   x:keep="" throws away all input attributes
   x:keep="space-separated-list-of-prefixed-attribute-names"
   x:lose="" keeps all input attributes
   x:lose="space-separated-list-of-prefixed-attribute-names"
   x:see="template-name-with-match"
   x:set="unique-name-of-attribute-set"
   x:set-comment="comment-for-attribute-set"
   x:use="names-of-attribute-sets"

   x:content-value="select-expression"
   x:content-apply="select-expression"
   x:content-mode="mode-name"
   x:content-name="template-name"
   x:content-call="template-name"
   x:content-copy="select-expression"
   x:content-variable="variable-name"
   x:content-verbatim="label-of-verbatim-element"
   x:content-post="template-name"

   x:copy-of="select-expression"
   x:value-of="select-expression"
   x:for-each="select-expression"

   x:name="template-name"
   x:apply-templates="select-expression"
   x:call-template="template-name"
   x:see="template-name"

   x:content-infix="label-of-verbatim-element"
   x:content-prefix="label-of-verbatim-element"
   x:content-suffix="label-of-verbatim-element"
   x:infix="label-of-verbatim-element"
   x:prefix="label-of-verbatim-element"
   x:suffix="label-of-verbatim-element"

   x:comment="string"
   x:order="number"

   x:strip="" - used only by striplit.xsl and not by this stylesheet
-->

<xs:namespace-alias>
  <para>
    When using XSLT 1.0 processor, the prefix in this stylesheet cannot be
    "xsl" and still have the result stylesheet using the "xsl" prefix, thus
    this aliasing is required, and XSLT is referenced in this stylesheet
    using the "xst" prefix.
  </para>
</xs:namespace-alias>
<xst:namespace-alias stylesheet-prefix="xsl" result-prefix="xst"/>

<xs:strip-space>
  <para>
    Presume all indentation in the input is cosmetic and that the user has
    used <literal>xml:space=</literal> to preserve significant white-space.
  </para>
</xs:strip-space>
<xst:strip-space elements="*"/>

<xs:preserve-space>
  <para>
    Of course any embedded XSLT text instructions must presume to preserve
    white-space-only text nodes.
  </para>
</xs:preserve-space>
<xst:preserve-space elements="xst:text"/>

<xs:variable>
  <para>Be able to refer to the source document when in a literal.</para>
</xs:variable>
<xst:variable name="xi:in" select="/" as="document-node()"/>

<!--========================================================================-->
<xs:doc>
  <xs:title>Keys for quick access</xs:title>
</xs:doc>

<xs:key>
  <para>All those elements that create template rules in the result</para>
</xs:key>
<xst:key name="x:templates" match="*[ @x:match | @x:name | @x:content-name ]" 
                            use="'all'"/>

<xs:key>
  <para>All those elements that create global variables in the result.</para>
</xs:key>
<xst:key name="x:variables" match="@x:content-variable" use="'all'"/>

<xs:key>
  <para>All declared chunks of verbatim XSLT code.</para>
</xs:key>
<xst:key name="x:verbatims" match="x:verbatim" use="@label"/>

<xs:key>
  <para>All declared attribute sets.</para>
</xs:key>
<xst:key name="x:sets" match="*[ @x:set ]" use="'all'"/>

<!--========================================================================-->
<xs:doc>
  <xs:title>Building the result stylesheet</xs:title>
</xs:doc>

<xs:template>
  <para>Where all processing begins</para>
</xs:template>
<xst:template match="/">
  <!--check for any problems-->
  <xst:call-template name="x:debug-exit"/>
  <!--create the result-->
  <xst:result-document 
                    indent="{if( //*[@xml:space='preserve']
                                    [not(tokenize(@x:lose,'\s+')='xml:space')])
                             then 'no' else 'yes'}">
    <!--prefix the output with an indication of the literate environment-->
    <xst:text>
</xst:text>
    <xst:comment>Stylesheet synthesized using the LiterateXSLT(TM) environment.</xst:comment>
  <xst:text>
</xst:text>
    <xst:comment>See http://www.CraneSoftwrights.com/links/res-lxslt.htm for available</xst:comment>
  <xst:text>
</xst:text>
    <xst:comment>resources, training and training materials from Crane Softwrights Ltd.</xst:comment>
  <xst:text>

</xst:text>

    <!--determine where all starts because it cannot start at the root node
        if the document element of the result matches a node that is not
        the document element of the source-->
    <xst:variable name="first-node-select-expr">
      <xst:choose>
        <xst:when test="key('x:templates','all')
                        [normalize-space(@x:match)='/']">
          <!--there already exists a template rule for the root node-->
        </xst:when>
        <xst:when test="/*/@x:apply-templates">
          <!--use document element select-->
          <xst:value-of select="/*/@x:apply-templates"/>
        </xst:when>
        <xst:otherwise>
          <!--use document element match as the first select-->
          <xst:value-of select="/*/@x:match"/>
        </xst:otherwise>
      </xst:choose>
    </xst:variable>

    <!--begin the result stylesheet-->
    <xst:element name="xsl:stylesheet" 
                 namespace="http://www.w3.org/1999/XSL/Transform">
      <!--add namespaces needed by the result tree, ignoring LiterateXSLT-->
      <xst:copy-of 
          select="*/namespace::*[ not( 
         starts-with( ., 'http://www.CraneSoftwrights.com/ns/literate-xslt') or
         . = 'http://www.w3.org/1999/XSL/Transform'  ) ]"/>
      <xst:namespace name="xsl"
                     select="'http://www.w3.org/1999/XSL/Transform'"/>
      <xst:for-each select="*/@x:exclude-result-prefixes">
        <xst:attribute name="exclude-result-prefixes" select="."/>
      </xst:for-each>
      <xst:for-each select="*/@x:xpath-default-namespace">
        <xst:attribute name="xpath-default-namespace" select="."/>
      </xst:for-each>
      <xst:attribute name="version">2.0</xst:attribute>
      <xst:text>
</xst:text>

      <!--respect the user expectations for indented production output-->
      <xst:element name="xsl:output"
                   namespace="http://www.w3.org/1999/XSL/Transform">
        <xst:attribute name="indent"
                       select="if( /*/@x:indent='yes' ) then 'yes' else 'no'"/>
      </xst:element>
      
      <xst:if test="string($first-node-select-expr)">
        <xst:comment>
Processing starts at node: <xst:value-of select="$first-node-select-expr"/>
See the template rule at end of stylesheet for the default processing of 
the root node.
</xst:comment>
      </xst:if>

      <!--accommodate interpretation of the input-->
      <xst:for-each select="( x:envelope/x:payload/* | * )/@x:strip-space">
        <xst:element name="xsl:strip-space"
                     namespace="http://www.w3.org/1999/XSL/Transform">
          <xst:attribute name="elements">
            <xst:value-of select="."/>
          </xst:attribute>
        </xst:element>
      </xst:for-each>
      <xst:for-each select="( x:envelope/x:payload/* | * )/@x:preserve-space">
        <xst:element name="xsl:preserve-space"
                     namespace="http://www.w3.org/1999/XSL/Transform">
          <xst:attribute name="elements">
            <xst:value-of select="."/>
          </xst:attribute>
        </xst:element>
      </xst:for-each>

      <!--find and create all of the templates from the literate result-->
      <xst:for-each select="key( 'x:templates', 'all' )">
        <xst:sort select="concat( @x:order,'0' )" data-type="number"/>
        <xst:sort select="concat( @x:name,'0xfffd' )"/><!--put unnamed last -->
        <xst:sort select="@x:match"/><!--sort by match pattern within group-->

        <xst:if test="@x:match | @x:name">
          <xst:call-template name="x:make-template-rule">
            <xst:with-param name="name" select="@x:name"/>
            <xst:with-param name="content" select="false()"/>
          </xst:call-template>
        </xst:if>

        <xst:if test="@x:content-name">
          <xst:call-template name="x:make-template-rule">
            <xst:with-param name="name" select="@x:content-name"/>
            <xst:with-param name="content" select="true()"/>
          </xst:call-template>
        </xst:if>
      </xst:for-each>

      <!--find and create all attribute sets from various elements-->
      <xst:call-template name="x:build-attribute-sets"/>

      <!--find and create all named variables for strings-->
      <xst:if test="key( 'x:variables', 'all')">
        <xst:text>

</xst:text>
        <xst:comment>top-level variables</xst:comment>
        <xst:text>
</xst:text>
        <xst:for-each select="key( 'x:variables', 'all' )">
          <xst:sort select="."/>
          <xst:element name="xsl:variable"
                       namespace="http://www.w3.org/1999/XSL/Transform">
            <xst:attribute name="name">
              <xst:value-of select="."/>
            </xst:attribute>
            <xst:apply-templates mode="x:copy-verbatim" 
                                 select="../node()"/>
          </xst:element>
        </xst:for-each>
      </xst:if>

      <!--find and declare all global variables-->
      <xst:for-each select="//x:global-variable">
        <xst:call-template name="x:local-variable"/>
      </xst:for-each>

      <!--there may be a leading comment-->
      <xst:call-template name="x:do-comment"/>

      <!--synthesize the processing of the root node-->
      <xst:choose>
        <xst:when test="string($first-node-select-expr)">
          <!--then the document element will have already created a template
              rule-->
          <xst:text>

</xst:text>
          <xst:element name="xsl:template" 
                       namespace="http://www.w3.org/1999/XSL/Transform">
            <xst:attribute name="match">/</xst:attribute>
          <!--the first element of the literate result dictates where
              processing starts, unless the writer has decided that an embedded
              template rule is going to match the root node with higher
              priority-->
            <xst:element name="xsl:apply-templates" 
                         namespace="http://www.w3.org/1999/XSL/Transform">
              <xst:attribute name="select">
                <xst:value-of select="$first-node-select-expr"/>
              </xst:attribute>
            </xst:element>
          </xst:element>
        </xst:when>
        <xst:when test="key('x:templates','all')
                        [normalize-space(@x:match)='/']">
          <!--no need to add another match for the root node-->
        </xst:when>
        <xst:otherwise>
          <!--need to create a template rule to get started-->
          <xst:element name="xsl:template" 
                       namespace="http://www.w3.org/1999/XSL/Transform">
            <xst:attribute name="match">/</xst:attribute>
            <!--using the document element-->
            <xst:apply-templates select="/*"/>
          </xst:element>          
        </xst:otherwise>
      </xst:choose>
    </xst:element>
  </xst:result-document>
</xst:template>

<xs:template>
  <para>
    Make a template rule for one of the annotated result elements that need
    one.  The current node is the annotated result element.
  </para>
  <xs:param name="name">
    <para>The name of the template rule, or empty for no name.</para>
  </xs:param>
  <xs:param name="content">
    <para>The content of the template rule.</para>
  </xs:param>
</xs:template>
<xst:template name="x:make-template-rule">
  <xst:param name="name" as="xsd:string?"/><!--supplied by caller-->
  <xst:param name="content" as="xsd:boolean"/>
  <xst:text>
</xst:text>
  <!--prefix the template with any verbatim content-->
  <xst:if test="@x:prefix and not($content)">
    <!--verbatim content for empty -->
    <xst:call-template name="x:copy-verbatim">
      <xst:with-param name="names" select="tokenize( @x:prefix, '\s+' )"/>
    </xst:call-template>
  </xst:if>
  <xst:if test="@x:content-prefix and $content">
    <xst:call-template name="x:copy-verbatim">
      <xst:with-param name="names" 
                      select="tokenize( @x:content-prefix, '\s+' )"/>
    </xst:call-template>
  </xst:if>
  <!--there may be a leading comment-->
  <xst:call-template name="x:do-comment"/>
  <!--start the template-->
  <xst:element name="xsl:template"
               namespace="http://www.w3.org/1999/XSL/Transform">
    <xst:if test="not($content)">
      <xst:for-each select="@x:match | @x:mode | @x:priority">
        <xst:attribute name="{local-name(.)}">
          <xst:value-of select="."/>
        </xst:attribute>
      </xst:for-each>
    </xst:if>
    <!--name the template-->
    <xst:if test="$name">
      <xst:attribute name="name" select="$name"/>
    </xst:if>
    <!--parameterize the template-->
    <xst:call-template name="x:params"/>
    <!--infix the template-->
    <xst:if test="@x:infix and not($content)">
      <xst:call-template name="x:copy-verbatim">
        <xst:with-param name="names" select="tokenize( @x:infix, '\s+' )"/>
      </xst:call-template>
    </xst:if>
    <xst:if test="@x:content-infix and $content">
      <xst:call-template name="x:copy-verbatim">
        <xst:with-param name="names" 
                        select="tokenize( @x:content-infix, '\s+' )"/>
      </xst:call-template>
    </xst:if>
    <!--fill the template-->
    <xst:choose>
      <xst:when test="$content">
        <!--the current element already handled-->
        <xst:choose>
          <xst:when test="x:replace"><!--skip immediate children-->
            <xst:apply-templates select="x:replace/node()"/>
          </xst:when>
          <xst:otherwise><!--process all immediate children-->
            <xst:apply-templates/>
          </xst:otherwise>
        </xst:choose>
      </xst:when>
      <xst:otherwise><!--include current element in the template-->
        <xst:apply-templates select=".">
          <xst:with-param name="making-a-template" select="true()"
                          tunnel="yes"/>
        </xst:apply-templates>
      </xst:otherwise>
    </xst:choose>
  </xst:element>
  <!--suffix the template-->
  <xst:if test="@x:suffix and not($content)">
    <xst:call-template name="x:copy-verbatim">
      <xst:with-param name="names" select="tokenize( @x:suffix, '\s+' )"/>
    </xst:call-template>
  </xst:if>
  <xst:if test="@x:content-suffix and $content">
    <xst:call-template name="x:copy-verbatim">
      <xst:with-param name="names" 
                            select="tokenize( @x:content-suffix, '\s+' )"/>
    </xst:call-template>
  </xst:if>
</xst:template>

<!--========================================================================-->
<xs:doc>
  <xs:title>Handle all text processing</xs:title>
</xs:doc>

<xs:template>
  <para>
    Any text node in the influence of <literal>xml:space="preserve"</literal>
    goes out as it is.  The output isn't indented, so no wrapping is required.
  </para>
</xs:template>
<xst:template 
             match="text()[ancestor::*[@xml:space][1][@xml:space='preserve']]">
  <xst:copy/>
</xst:template>

<xs:template>
  <para>
    Any text node in the influence of <literal>xml:space="preserve"</literal>
    where the xml:space attribute is not preserved needs to go out with
    a text instruction.
  </para>
</xs:template>
<xst:template priority="1" 
              match="text()[ancestor::*[@xml:space][1][@xml:space='preserve']
                    [tokenize(@x:lose,'\s+')='xml:space']]">
  <xst:element name="xsl:text"
               namespace="http://www.w3.org/1999/XSL/Transform">
    <xst:copy/>
  </xst:element>
</xst:template>

<xs:template>
  <para>
    Implicit text node put into a wrapper because the stylesheet may be
    indented
  </para>
</xs:template>
<xst:template match="text()">
  <xst:element name="xsl:text" 
               namespace="http://www.w3.org/1999/XSL/Transform">
    <xst:copy/>
  </xst:element>
</xst:template>

<xs:template>
  <para>
    An existing <literal>&lt;xsl:text></literal> instruction needs to be
    preserved.
  </para>
</xs:template>
<xst:template match="xst:text">
  <xst:copy-of select="."/>
</xst:template>

<!--========================================================================-->
<xs:doc>
  <xs:title>Result element handling</xs:title>
</xs:doc>

<xs:template>
  <para>
    Comments can be made in a number of situations
  </para>
</xs:template>
<xst:template name="x:do-comment">
  <xst:for-each select="@x:comment"><!--possible preamble-->
    <xst:text>
</xst:text>
    <xst:comment><xst:value-of select="."/></xst:comment>
  </xst:for-each>
</xst:template>

<xs:template>
  <para>
    At this point a result tree element is being acted on, which may produce
    many different results.
  </para>
  <xs:param name="making-a-template">
    <para>
      An indication this is being called in order to reconstitute the element
      as part of making a template.
    </para>
  </xs:param>
</xs:template>
<xst:template match="*">
  <xst:param name="making-a-template" as="xsd:boolean" select="false()"
             tunnel="yes"/>

  <xst:if test="not($making-a-template)">
    <xst:call-template name="x:do-comment"/>
  </xst:if>

  <!--the conditional processing supplements the entire set of attributes-->
  <xst:choose>
    <xst:when test="@x:condition">
      <xst:element name="xsl:if"
                   namespace="http://www.w3.org/1999/XSL/Transform">
        <xst:attribute name="test" select="@x:condition"/>
        <xst:call-template name="x:process-literate-attributes"/>
      </xst:element>
    </xst:when>
    <xst:otherwise>
      <xst:call-template name="x:process-literate-attributes"/>
    </xst:otherwise>
  </xst:choose>
</xst:template>

<xs:template>
  <para>
    At this point the condition for the generation of the result tree element
    has been tested so now it is time to interpret the rest.
  </para>
  <xs:param name="making-a-template">
    <para>
      An indication this is being called in order to reconstitute the element
      as part of making a template.
    </para>
  </xs:param>
</xs:template>
<xst:template name="x:process-literate-attributes">
  <xst:param name="making-a-template" as="xsd:boolean" select="false()"
             tunnel="yes"/>
  <xst:choose>
    <xst:when test="@x:ignore">
      <!--the element does not participate in generating a stylesheet-->
    </xst:when>

    <xst:when test="@x:see"><!--nothing more to do here; handled elsewhere-->
      <xst:if test="@x:see='' and not( preceding-sibling::*[@x:for-each] )">
        <xst:call-template name="x:error">
          <xst:with-param name="msg">
            <xst:text>Element with unlabeled x:see attribute is </xst:text>
            <xst:text>missing a preceding sibling with x:for-each</xst:text>
          </xst:with-param>
        </xst:call-template>
      </xst:if>
    </xst:when>

    <!--check for apply, match, call or name when not starting a template, 
        because the first element of the template has to be the element 
        from which the tempate was derived; those elements that are not 
        the first are replaced with apply-templates-->
    <xst:when test="@x:apply-templates and not($making-a-template)">
      <xst:element name="xsl:apply-templates"
                   namespace="http://www.w3.org/1999/XSL/Transform">
        <xst:attribute name="select" select="@x:apply-templates"/>
        <xst:if test="@x:mode">
          <xst:attribute name="mode" select="@x:mode"/>
        </xst:if>
      </xst:element>
    </xst:when>

    <xst:when test="@x:match and not($making-a-template)">
      <xst:element name="xsl:apply-templates"
                   namespace="http://www.w3.org/1999/XSL/Transform">
        <xst:attribute name="select" select="@x:match"/>
        <xst:if test="@x:mode">
          <xst:attribute name="mode" select="@x:mode"/>
        </xst:if>
      </xst:element>
    </xst:when>

    <xst:when test="@x:for-each and 
                    @x:call-template and not($making-a-template)">
      <xst:element name="xsl:for-each"
                   namespace="http://www.w3.org/1999/XSL/Transform">
        <xst:attribute name="select" select="@x:for-each"/>
        <xst:element name="xsl:call-template"
                     namespace="http://www.w3.org/1999/XSL/Transform">
          <xst:attribute name="name" select="@x:call-template"/>
          <xst:call-template name="x:with-params"/>
        </xst:element>
      </xst:element>
    </xst:when>

    <xst:when test="@x:call-template and not($making-a-template)">
      <xst:element name="xsl:call-template"
                   namespace="http://www.w3.org/1999/XSL/Transform">
        <xst:attribute name="name" select="@x:call-template"/>
        <xst:call-template name="x:with-params"/>
      </xst:element>
    </xst:when>

    <xst:when test="@x:for-each and 
                    @x:name and not($making-a-template)">
      <xst:element name="xsl:for-each"
                   namespace="http://www.w3.org/1999/XSL/Transform">
        <xst:attribute name="select" select="@x:for-each"/>
        <xst:element name="xsl:call-template"
                     namespace="http://www.w3.org/1999/XSL/Transform">
          <xst:attribute name="name" select="@x:name"/>
          <xst:call-template name="x:with-params"/>
        </xst:element>
      </xst:element>
    </xst:when>

    <xst:when test="@x:name and not($making-a-template)">
        <xst:element name="xsl:call-template"
                     namespace="http://www.w3.org/1999/XSL/Transform">
          <xst:attribute name="name" select="@x:name"/>
          <xst:call-template name="x:with-params"/>
        </xst:element>
    </xst:when>

    <xst:when test="@x:for-each and not(@x:name)">
      <xst:element name="xsl:for-each"
                   namespace="http://www.w3.org/1999/XSL/Transform">
        <xst:attribute name="select" select="@x:for-each"/>
        <xst:call-template name="x:reproduce-element"/>
      </xst:element>
    </xst:when>

    <xst:when test="@x:copy-of">
      <xst:element name="xsl:copy-of"
                   namespace="http://www.w3.org/1999/XSL/Transform">
        <xst:attribute name="select" select="@x:copy-of"/>
        <!--no content preserved because it will be overwritten-->
      </xst:element>
    </xst:when>

    <xst:when test="@x:value-of">
      <xst:element name="xsl:value-of"
                   namespace="http://www.w3.org/1999/XSL/Transform">
        <xst:attribute name="select" select="@x:value-of"/>
        <!--no content preserved because it will be overwritten-->
      </xst:element>
    </xst:when>

    <!--all other elements are result elements that need to be copied-->
    <xst:otherwise>
      <xst:call-template name="x:reproduce-element">
       <xst:with-param name="making-a-template" select="false()" tunnel="yes"/>
      </xst:call-template>
    </xst:otherwise>
  </xst:choose>
</xst:template>

<xs:template>
  <para>
    At this point the current node needs to be replicated in the stylesheet,
    but that doesn't happen when the current node is
    <literal>&lt;x:branch</literal>, in which case only the content is
    handled.
  </para>
</xs:template>
<xst:template name="x:reproduce-element">
  <xst:choose>
    <xst:when test="self::x:branch">
      <xst:call-template name="x:do-content-and-post"/>
    </xst:when>
    <xst:otherwise>
      <xst:element name="{name(.)}" namespace="{namespace-uri(.)}">
        <xst:call-template name="x:do-attributes"/>
        <xst:call-template name="x:do-content-and-post"/>
      </xst:element>
    </xst:otherwise>
  </xst:choose>
</xst:template>

<xs:template>
  <para>
    Find all the child parameters for a named template
  </para>
</xs:template>
<xst:template name="x:params">
  <xst:for-each select="x:param">
    <xst:element name="xsl:param"
                 namespace="http://www.w3.org/1999/XSL/Transform">
      <xst:copy-of select="@*"/>
      <xst:apply-templates/>
    </xst:element>
  </xst:for-each>
</xst:template>

<xs:template>
  <para>
    Find all the calling parameters for a called template
  </para>
</xs:template>
<xst:template name="x:with-params">
  <xst:for-each select="x:with-param">
    <xst:element name="xsl:with-param"
                 namespace="http://www.w3.org/1999/XSL/Transform">
      <xst:copy-of select="@*"/>
      <xst:apply-templates/>
    </xst:element>
  </xst:for-each>
</xst:template>

<!--========================================================================-->
<xs:doc>
  <xs:title>Attribute processing</xs:title>
</xs:doc>

<xs:template>
  <para>
    Building attribute sets from collections of attributes in the input.  This
    is done at the start of processing before the elements are pushed through
    the template rules.
  </para>
</xs:template>
<xst:template name="x:build-attribute-sets">
  <!--find and create all generated attribute sets-->
  <xst:for-each select="key( 'x:sets', 'all' )">
    <xst:sort select="@x:set"/>
    <xst:text>
</xst:text>
    <!--documentation for the attribute set-->
    <xst:for-each select="@x:set-comment">
      <xst:text>
</xst:text>
      <xst:comment>
        <xst:value-of select="."/>
      </xst:comment>
      <xst:text>
</xst:text>
    </xst:for-each>

    <!--create the names attribute set-->
    <xst:element name="xsl:attribute-set" 
                 namespace="http://www.w3.org/1999/XSL/Transform">
      <xst:attribute name="name">
        <xst:value-of select="@x:set"/>
      </xst:attribute>
      <xst:variable name="non-literate-attrs" select="@* except (@x:*|@a:*)"/>

      <xst:choose>
        <xst:when test="@x:keep"><!--use what isn't kept-->
          <xst:apply-templates mode="x:build-one-attribute"
              select="$non-literate-attrs[name()=tokenize(../@x:keep,'\s+')]"/>
        </xst:when>
        <xst:when test="@x:lose"><!--use what isn't lost-->
          <xst:apply-templates mode="x:build-one-attribute"
         select="$non-literate-attrs[not(name()=tokenize(../@x:lose,'\s+'))]"/>
        </xst:when>
        <xst:otherwise><!--all attributes are game!-->
          <xst:apply-templates mode="x:build-one-attribute" 
                               select="$non-literate-attrs"/>
        </xst:otherwise>
      </xst:choose>
    </xst:element>
  </xst:for-each>
</xst:template>

<xs:template>
  <para>
    Copy a single attribute to the result using an instruction instead of a
    literal result attribute.  This satisfies the building of attribute sets
    as well as the reconsitition of prototypical attributes.
  </para>
</xs:template>
<xst:template mode="x:build-one-attribute" match="@*">
  <xst:variable name="newvaluenode"
                select="../@a:*[local-name()=local-name(current())]"/>
  <xst:element name="xsl:attribute"
               namespace="http://www.w3.org/1999/XSL/Transform">
    <xst:attribute name="name" select="name(.)"/>
    <xst:choose>
      <!--use the supplied new value as an XPath expression-->
      <xst:when test="$newvaluenode">
        <xst:attribute name="select" select="$newvaluenode"/>
      </xst:when>
      <xst:otherwise>
        <xst:value-of select="."/><!--use existing value-->
      </xst:otherwise>
    </xst:choose>
  </xst:element>
</xst:template>

<xs:template>
  <para>Copy attributes from the input</para>
</xs:template>
<xst:template name="x:do-attributes">
  <xst:variable name="non-literate-attrs" 
                select="@* except 
                        ( self::xst:*/@*[not(namespace-uri(.))] |
                          @xst:* | @x:* | @a:* )"/>

  <!--preserve XSLT vocabulary attributes as they are-->
  <xst:copy-of select="self::xst:*/@*,@xst:*"/>
 
  <!--point to the attributes needed for this element-->
  <xst:if test="@x:use or @x:set">
    <xst:attribute name="xsl:use-attribute-sets" 
                   namespace="http://www.w3.org/1999/XSL/Transform">
      <xst:value-of select="concat( @x:use, ' ', @x:set )"/>
    </xst:attribute>
  </xst:if>

  <!--process the result and literate attributes-->
  <xst:choose>
    <xst:when test="@x:set">
      <!--assume all kept or lost are in the set when the set was built-->
    </xst:when>
    <!--otherwise, not using an attribute set, so now look at keep/lose-->
    <xst:when test="@x:keep">
      <xst:call-template name="x:copy-specific-attributes">
        <xst:with-param name="attributes"
              select="$non-literate-attrs[name()=tokenize(../@x:keep,'\s+')]"/>
      </xst:call-template>
    </xst:when>
    <xst:when test="@x:lose">
      <xst:call-template name="x:copy-specific-attributes">
        <xst:with-param name="attributes"
         select="$non-literate-attrs[not(name()=tokenize(../@x:lose,'\s+'))]"/>
      </xst:call-template>
    </xst:when>
    <xst:otherwise><!--all attributes are game!-->
      <xst:call-template name="x:copy-specific-attributes">
        <xst:with-param name="attributes" select="$non-literate-attrs"/>
      </xst:call-template>
    </xst:otherwise>
  </xst:choose>
</xst:template>

<xs:template>
  <para>
    Copy the attributes for the current element node to the result using
    a literal result attribute for the fixed values and an instruction for
    the calculated values.
  </para>
  <xs:param name="attributes">
    <para>
      The non-literate source tree attributes to copy. Use literal result 
      attributes for fixed values and attribute instructions for calculations.
    </para>
  </xs:param>
</xs:template>
<xst:template name="x:copy-specific-attributes">
  <xst:param name="attributes" as="attribute()*"/>
  <!--which of the sibling attributes are ones with overrides-->
  <xst:variable name="literateAttributeNames" select="@a:*/local-name()"/>
  <!--which of the given attributes have overrides-->
  <xst:variable name="overriddenResultAttributes"
                select="$attributes[local-name(.)=$literateAttributeNames]"/>
  <xst:variable name="overriddenResultAttributeNames" 
                select="$overriddenResultAttributes/local-name(.)"/>
  <!--which of the literate attributes do not have default values-->
  <xst:variable name="newLiterateAttributes"
             select="@a:*[not(local-name()=$overriddenResultAttributeNames)]"/>
  <!--first add the literal result attributes-->
  <xst:copy-of select="$attributes"/>
  <!--then add the overrides for specified attributes-->
  <xst:for-each select="$overriddenResultAttributes">
    <xst:call-template name="x:conditional-attribute-evaluation">
      <xst:with-param name="name" select="name(.)"/>
      <xst:with-param name="calculation" 
                     select="../@a:*[local-name(.)=local-name(current())]"/>
    </xst:call-template>
  </xst:for-each>
  <!--finally add the "overrides" for attributes not specified-->
  <xst:for-each select="$newLiterateAttributes">
    <xst:call-template name="x:conditional-attribute-evaluation">
      <xst:with-param name="name" select="local-name(.)"/>
      <xst:with-param name="calculation" select="."/>
    </xst:call-template>
  </xst:for-each>
</xst:template>

<xs:template>
  <para>
    Check that the calculated attribute to be added needs to be non-empty.
    The current node is an attribute node, either the attribute being
    overridden, or the calculation attribute.
  </para>
  <para>
    While there are convenient XSLT 2.0 ways of doing this, to be portable
    with XSLT 1.0 it must be done in a cumbersome fashion.
  </para>
  <xs:param name="name">
    <para>The name of the attribute to be added</para>
  </xs:param>
  <xs:param name="calculation">
    <para>How the value of the attribute is calculated.</para>
  </xs:param>
</xs:template>
<xst:template name="x:conditional-attribute-evaluation">
  <xst:param name="name" as="xsd:string"/>
  <xst:param name="calculation" as="attribute()"/>
  <xst:variable name="varname" select="concat('variable_',generate-id(.))"/>
  <!--declare a variable in which the value is calculated-->
  <xst:element name="xsl:variable"
               namespace="http://www.w3.org/1999/XSL/Transform">
    <xst:attribute name="name" select="$varname"/>
    <xst:element name="xsl:value-of"
                 namespace="http://www.w3.org/1999/XSL/Transform">
      <xst:attribute name="select" select="$calculation"/>
    </xst:element>
  </xst:element>
  <!--check if the string value is non-empty, and if so, add attribute-->
  <xst:element name="xsl:if"
               namespace="http://www.w3.org/1999/XSL/Transform">
    <xst:attribute name="test"
                   select="concat('string($',$varname,')')"/>
    <xst:element name="xsl:attribute"
                 namespace="http://www.w3.org/1999/XSL/Transform">
      <xst:attribute name="name" select="$name"/>
      <xst:element name="xsl:value-of"
                   namespace="http://www.w3.org/1999/XSL/Transform">
    <xst:attribute name="select"
                   select="concat('string($',$varname,')')"/>
      </xst:element>
    </xst:element>
  </xst:element>
</xst:template>

<!--========================================================================-->
<xs:doc>
  <xs:title>Content replacement facilities</xs:title>
</xs:doc>

<xs:template>
  <para>Handle the content for a given element and post-process it</para>
</xs:template>
<xst:template name="x:do-content-and-post">
  <xst:choose>
    <xst:when test="@x:content-post">
      <xst:element name="xsl:call-template"
                   namespace="http://www.w3.org/1999/XSL/Transform">
        <xst:attribute name="name">
          <xst:value-of select="@x:content-post"/>
        </xst:attribute>
        <xst:element name="xsl:with-param"
                     namespace="http://www.w3.org/1999/XSL/Transform">
          <xst:attribute name="name">value</xst:attribute>
          <xst:call-template name="x:do-content"/>
        </xst:element>
      </xst:element>
    </xst:when>
    <xst:otherwise>
      <xst:call-template name="x:do-content"/>
    </xst:otherwise>
  </xst:choose>
</xst:template>

<xs:template>
  <para>Handle the content for a given element</para>
</xs:template>
<xst:template name="x:do-content">
  <xst:choose><!--check for signal to replace content by an instruction-->
    <xst:when test="@x:content-apply=''">
      <xst:element name="xsl:apply-templates"
        namespace="http://www.w3.org/1999/XSL/Transform">
        <xst:if test="@x:content-mode">
          <xst:attribute name="mode">
            <xst:value-of select="@x:content-mode"/>
          </xst:attribute>
        </xst:if>
      </xst:element>
    </xst:when>
    <xst:when test="@x:content-apply">
      <xst:element name="xsl:apply-templates"
        namespace="http://www.w3.org/1999/XSL/Transform">
        <xst:attribute name="select">
          <xst:value-of select="@x:content-apply"/>
        </xst:attribute>
        <xst:if test="@x:content-mode">
          <xst:attribute name="mode">
            <xst:value-of select="@x:content-mode"/>
          </xst:attribute>
        </xst:if>
      </xst:element>
    </xst:when>
    <xst:when test="@x:content-call">
      <xst:element name="xsl:call-template"
        namespace="http://www.w3.org/1999/XSL/Transform">
        <xst:attribute name="name">
          <xst:value-of select="@x:content-call"/>
        </xst:attribute>
        <xst:call-template name="x:with-params"/>
      </xst:element>
    </xst:when>
    <xst:when test="@x:content-name">
      <xst:element name="xsl:call-template"
        namespace="http://www.w3.org/1999/XSL/Transform">
        <xst:attribute name="name">
          <xst:value-of select="@x:content-name"/>
        </xst:attribute>
        <xst:call-template name="x:with-params"/>
      </xst:element>
    </xst:when>
    <xst:when test="@x:content-value">
      <xst:element name="xsl:value-of"
        namespace="http://www.w3.org/1999/XSL/Transform">
        <xst:attribute name="select">
          <xst:value-of select="@x:content-value"/>
        </xst:attribute>
      </xst:element>
    </xst:when>
    <xst:when test="@x:content-variable">
      <xst:element name="xsl:copy-of"
        namespace="http://www.w3.org/1999/XSL/Transform">
        <xst:attribute name="select">
          <xst:text>$</xst:text>
          <xst:value-of select="@x:content-variable"/>
        </xst:attribute>
      </xst:element>
    </xst:when>
    <xst:when test="@x:content-copy">
      <xst:element name="xsl:copy-of"
        namespace="http://www.w3.org/1999/XSL/Transform">
        <xst:attribute name="select">
          <xst:value-of select="@x:content-copy"/>
        </xst:attribute>
      </xst:element>
    </xst:when>
    <xst:when test="@x:content-verbatim">
      <xst:call-template name="x:copy-verbatim">
        <xst:with-param name="names" 
                        select="tokenize( @x:content-verbatim, '\s+ ')"/>
      </xst:call-template>
    </xst:when>
    <!--nothing yet exists for x:content-for-each;
        not sure if this feature is needed or not-->
    <xst:when test="x:replace">
      <!--skip other child nodes of this node; only do x:replace-->
      <xst:apply-templates select="x:replace/node()" 
                           mode="x:copy-verbatim"/>
    </xst:when>
    <xst:otherwise>
      <xst:apply-templates/>
    </xst:otherwise>
  </xst:choose>
</xst:template>

<!--========================================================================-->
<xs:doc>
  <xs:title>Variable processing</xs:title>
  <para>
    Variables can be declared at either a local or global scope.
  </para>
</xs:doc>

<xs:template>
  <para>
    Do nothing when encountering a global variable or parameter because it
    has already been processed before it is encountered
  </para>
</xs:template>
<xst:template match="x:global-variable | x:param | x:with-param"/>

<xs:template>
  <para>
    When encountering a local variable, declare it in its context.
  </para>
</xs:template>
<xst:template match="x:local-variable" name="x:local-variable">
  <xst:element name="xsl:variable"
               namespace="http://www.w3.org/1999/XSL/Transform">
    <xst:copy-of select="@*"/>
    <xst:apply-templates/>
  </xst:element>
</xst:template>

<!--========================================================================-->
<xs:doc>
  <xs:title>Verbatim processing</xs:title>
  <para>
    All of the content in a verbatim element should be stylesheet content,
    so copying the stylesheet content into the result stylesheet should
    be preserved as is (no special handling of <literal>xml:space</literal>).
  </para>
</xs:doc>

<xs:template>
  <para>
    Do nothing with actual verbatim elements encountered in order, as they
    are only used by reference.
  </para>
</xs:template>
<xst:template match="x:verbatim"/>

<xs:template>
  <para>
    Now is the time to pull in the labeled verbatim content.
  </para>
  <xs:param name="names">
    <para>The list of named verbatim chunks to be pulled in.</para>
  </xs:param>
</xs:template>
<xst:template name="x:copy-verbatim">
  <xst:param name="names" as="xsd:string*"/>
  <xst:text>

</xst:text>
  <xst:for-each select="$names">
    <xst:apply-templates mode="x:copy-verbatim" 
                         select="key( 'x:verbatims', ., $xi:in )/node()"/>
  </xst:for-each>
</xst:template>

<xs:template>
  <para>Preserve any annotations</para>
</xs:template>
<xst:template mode="x:copy-verbatim" 
              match="comment()|processing-instruction()">
  <xst:copy/>
</xst:template>

<xs:template>
  <para>Reconstitute any verbatim elements.</para>
</xs:template>
<xst:template mode="x:copy-verbatim" match="*">
  <xst:element name="{name(.)}" namespace="{namespace-uri(.)}">
    <xst:copy-of select="@*"/>
    <xst:apply-templates mode="x:copy-verbatim" select="node()"/>
  </xst:element>
</xst:template>

<xs:template>
  <para>
    Preserve all text nodes because this is stylesheet content, not result
    content.
  </para>
</xs:template>
<xst:template mode="x:copy-verbatim" match="text()">
  <xst:copy/>
</xst:template>

<!--========================================================================-->
<xs:doc>
  <xs:title>Error reporting</xs:title>
</xs:doc>

<xs:template>
  <para>
    When encountering a conditional message, test the condition.
  </para>
</xs:template>
<xst:template match="x:message[string(@condition)]">
  <xst:element name="xsl:if"
               namespace="http://www.w3.org/1999/XSL/Transform">
    <xst:attribute name="test" select="@condition"/>
    <xst:next-match/>
  </xst:element>
</xst:template>

<xs:template>
  <para>
    When encountering an unconditional message, report it.
  </para>
</xs:template>
<xst:template match="x:message">
  <xst:element name="xsl:message"
               namespace="http://www.w3.org/1999/XSL/Transform">
    <xst:if test="@terminate='yes'">
      <xst:attribute name="terminate">yes</xst:attribute>
    </xst:if>
    <xst:apply-templates/>
  </xst:element>
</xst:template>

<xs:template>
  <para>Report an error (non-fatal).</para>
  <xs:param name="msg">
    <para>The message to report</para>
  </xs:param>
</xs:template>
<xst:template name="x:error">
  <xst:param name="msg" as="xsd:string?"/>
  <xst:message>
    <xst:text>Error: </xst:text>
    <xst:call-template name="x:context"/>
    <xst:text disable-output-escaping="yes"> ==>
       </xst:text>
<xst:copy-of select="$msg"/>
</xst:message>
</xst:template>

<xs:template>
  <para>Report a document context suitable for XPath searching</para>
</xs:template>
<xst:template name="x:context">
  <xst:for-each select="ancestor-or-self::*"><!--show context-->
    <xst:text>/</xst:text>
    <xst:value-of select="name(.)"/>
    <xst:if test="..[self::*]">
      <xst:text/>[<xst:number/>]<xst:text/>
    </xst:if>
  </xst:for-each>
  <xst:if test="not(self::*)">
    <xst:text/>/@<xst:value-of select="name(.)"/>
  </xst:if>
</xst:template>

<xs:key>
  <para>Track references to verbatim content.</para>
</xs:key>
<xst:key name="x:verbatim-refs" match="@x:prefix | @x:suffix | @x:infix "
                                use="'all'"/>

<xs:key>
  <para>Track see-also references.</para>
</xs:key>
<xst:key name="x:sees" match="@x:see[. != '']" use="'all'"/>

<xs:key>
  <para>Track templates that have match attributes by their name.</para>
</xs:key>
<xst:key name="x:templates-with-matches" match="*[ @x:match ]" use="@x:name"/>

<xs:key>
  <para>Track references to attribute sets.</para>
</xs:key>
<xst:key name="x:sets-unique" match="@x:set" use="."/>

<xs:key>
  <para>Track the creation of variables.</para>
</xs:key>
<xst:key name="x:variables-unique" match="@x:content-variable" use="."/>

<xs:variable>
  <para>
    Various checks of input criteria.  Should any fail each that do will
    leave a breadcrumb in the variable.  If the variable is then non-empty
    there must have been an error reported.
  </para>
</xs:variable>
<xst:variable name="xi:debug" as="xsd:string*">
  <!--check the verbatim elements-->
  <xst:for-each select="key( 'x:verbatim-refs', 'all' )">
    <xst:call-template name="x:check-verbatim">
      <xst:with-param name="names" select="tokenize( ., '\s+' )"/>
    </xst:call-template>
  </xst:for-each>
  <!--check that each see also has a corresponding template-->
  <xst:for-each select="key( 'x:sees', 'all' )">
    <xst:if test="not( key( 'x:templates-with-matches', . ) )">
      Error
      <xst:call-template name="x:error">
        <xst:with-param name="msg">
          <xst:text>Missing template rule with the name: </xst:text>
          <xst:value-of select="."/>
        </xst:with-param>
      </xst:call-template>
    </xst:if>
  </xst:for-each>
  <!--check for no duplicates of attribute sets-->
  <xst:for-each select="key( 'x:sets', 'all' )/@x:set">
    <xst:if test="count( key( 'x:sets-unique', . ) ) != 1">
      Error
      <xst:call-template name="x:error">
        <xst:with-param name="msg">
          <xst:text>Cannot have attribute sets with the same name: </xst:text>
          <xst:value-of select="."/>
          <xst:for-each select="key( 'x:sets-unique', . )">
            <xst:text>
       </xst:text>
            <xst:call-template name="x:context"/>
          </xst:for-each>
        </xst:with-param>
      </xst:call-template>
    </xst:if>
  </xst:for-each>
  <!--check for no duplicates of errors-->
  <xst:for-each select="key( 'x:variables', 'all' )">
    <xst:if test="count( key( 'x:variables-unique', . ) ) != 1">
      Error
      <xst:call-template name="x:error">
        <xst:with-param name="msg">
        <xst:text>Cannot have content variables with the same name: </xst:text>
          <xst:value-of select="."/>
          <xst:for-each select="key( 'x:variables-unique', . )/..">
            <xst:text>
       </xst:text>
            <xst:call-template name="x:context"/>
          </xst:for-each>
        </xst:with-param>
      </xst:call-template>
    </xst:if>
  </xst:for-each>
</xst:variable>

<xs:template>
  <para>Check a set of verbatim chunk names for being resolvable.</para>
  <xs:param name="names">
    <para>The list of names.</para>
  </xs:param>
</xs:template>
<xst:template name="x:check-verbatim">
  <xst:param name="names" as="xsd:string*"/>
  <xst:for-each select="$names">
    <xst:if test="count( key( 'x:verbatims', ., $xi:in ) ) = 0">
      Error
      <xst:call-template name="x:error">
        <xst:with-param name="msg">
          <xst:text>Missing verbatim content labeled: </xst:text>
          <xst:value-of select="."/>
        </xst:with-param>
      </xst:call-template>
    </xst:if>
    <xst:if test="count( key( 'x:verbatims', ., $xi:in ) ) > 1">
      Error
      <xst:call-template name="x:error">
        <xst:with-param name="msg">
          <xst:text>Too many choices of verbatim content labeled: </xst:text>
          <xst:value-of select="."/>
          <xst:for-each select="key( 'x:verbatims', ., $xi:in )">
            <xst:text>
</xst:text>
            <xst:call-template name="x:context"/>
          </xst:for-each>
        </xst:with-param>
      </xst:call-template>
    </xst:if>
  </xst:for-each>
</xst:template>

<xs:template>
  <para>
    Exit if there are any problems detected, as indicated by a non-empty
    debug string.
  </para>
</xs:template>
<xst:template name="x:debug-exit">
  <xst:if test="string-join($xi:debug,'')">
    <!--<xst:message>Debug: <xst:value-of select="$xi:debug"/></xst:message>-->
    <xst:message terminate="yes">Terminating execution ...</xst:message>
  </xst:if>
</xst:template>

</xst:stylesheet>
