<?xml version="1.0" encoding="iso-8859-1"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:x="http://www.CraneSoftwrights.com/ns/literate-xslt"
  xmlns:a="http://www.CraneSoftwrights.com/ns/literate-xslt/attribute"
  version="1.0">

<!--$Id: key2text.xsl,v 1.4 2003/10/18 15:08:17 G. Ken Holman Exp $-->
<!--This produces a three-column report indicating the key value, the
    XPath address to the key value, and the value that was replaced by
    the key value (values of attributes in non-null namespaces are not
    preserved).  It is assumed that the instance has been produced by
    the keyxml.xsl stylesheet from a representative data file. 

    Parameters:

       values=yes (to expose the value column)
       repeat=yes (to distinguish like sibling elements)
-->

<!--
Copyright (C) - Crane Softwrights Ltd.
              - http://www.CraneSoftwrights.com/links/res-lxslts.htm

Redistribution and use in source and binary forms, with or without 
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, 
  this list of conditions and the following disclaimer. 
- Redistributions in binary form must reproduce the above copyright notice, 
  this list of conditions and the following disclaimer in the documentation 
  and/or other materials provided with the distribution. 
- The name of the author may not be used to endorse or promote products 
  derived from this software without specific prior written permission. 

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN 
NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Note: for your reference, the above is the "Modified BSD license", this text
      was obtained 2003-07-26 at http://www.xfree86.org/3.3.6/COPYRIGHT2.html#5
-->

<xsl:import href="key2html.xsl"/><!--see this stylesheet for parameters-->

<xsl:output method="text"/>

<xsl:template match="/">
  <xsl:if test="/*/@x:label">
    <xsl:value-of select="/*/@x:label"/><xsl:text>
</xsl:text>
  </xsl:if>
  <xsl:call-template name="do-rows"/>
</xsl:template>

<xsl:template name="do-row">
  <xsl:value-of select="translate( ., '!', '' )"/>
  <xsl:text> </xsl:text>
  <xsl:choose>
    <xsl:when test="self::*">
      <xsl:value-of select="@x:path"/>
    </xsl:when>
    <xsl:otherwise>
      <xsl:value-of select="../@x:path"/>
      <xsl:text/>/@<xsl:value-of select="name(.)"/>
    </xsl:otherwise>
  </xsl:choose>
  <xsl:if test="$values">
    <!--get the value that was preserved in the instance-->
    <xsl:text> </xsl:text>
    <xsl:choose>
      <xsl:when test="self::*">
        <xsl:value-of select="@x:value"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of 
                select="../@a:*[local-name(.)=name(current())]"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:if>
  <xsl:text>
</xsl:text>
</xsl:template>

</xsl:stylesheet>
